Convert HTML links to Textile/Markdown links when creating an issue from an email

2019-07-08 10:25 - Yuichi HARADA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Email receiving Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution: Fixed Affected version:  

Description

When creating an issue from HTML format email, the href attribute of the A tag disappears, and only the string is acquired.

[Input]

foo<a href="http://example.com/">bar</a>baz

 [Expected]

foo "bar":http://example.com/ baz

 [Actual]

foobarbaz

Associated revisions

Revision 18361 - 2019-08-11 07:01 - Go MAEDA

Convert HTML links to Textile/Markdown links when creating an issue from an email (#31695).

Patch by Yuichi HARADA.

Revision 18988 - 2019-11-09 07:06 - Go MAEDA

Fix that receiving HTML email fails if it contains a link without an href attribute (#31695).

Patch by Marius BALTEANU.

History

#1 - 2019-07-08 10:35 - Yuichi HARADA

- File fixed-31695.patch added

I attached a patch for Textile and Markdown.

#2 - 2019-07-31 10:21 - Go MAEDA

- Target version set to Candidate for next major release

#3 - 2019-08-05 08:54 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

Setting the target version to 4.1.0.

#4 - 2019-08-11 07:02 - Go MAEDA

- Subject changed from Convert the A tag to Textile / Markdown when creating an issues from HTML email to Convert HTML links to Textile/Markdown

links when creating an issue from an email

- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for improving Redmine.

#5 - 2019-11-04 21:11 - Marius BĂLTEANU

- File tests_for_a_elements_without_href.patch added

- File fix_for_links_without_href.patch added

- Status changed from Closed to Reopened

The current implementation fails with the following error if the link doesn't contain the href attribute.

Error:

Redmine::WikiFormatting::MarkdownHtmlParserTest#test_should_not_convert_a_tag_without_href:

NoMethodError: undefined method `value' for nil:NilClass

    lib/redmine/wiki_formatting/markdown/html_parser.rb:40:in `block in <class:HtmlParser>'

    lib/redmine/wiki_formatting/html_parser.rb:58:in `scrub'

    lib/redmine/wiki_formatting/html_parser.rb:36:in `to_text'

    test/unit/lib/redmine/wiki_formatting/markdown_html_parser_test.rb:41:in `test_should_not_convert_a_tag_wi

thout_href'

 I'm attaching:

1. Tests for for markdown and textile which fail on the current trunk

2. A proposed fix, but I'm not sure if foo<a name="Header-one">bar</a>baz should be converted to foo bar baz or to foobarbaz.

#6 - 2019-11-05 23:00 - Go MAEDA

Marius BALTEANU wrote:

The current implementation fails with the following error if the link doesn't contain the href attribute.

 Thank you for catching and fixing the error.

2. A proposed fix, but I'm not sure if foo<a name="Header-one">bar</a>baz should be converted to foo bar baz or to foobarbaz.

 I think we can omit the surrounding spaces for that case. Text generated from `<a href="http://www.example.com/">foo</a>` style HTML should have

surrounding spaces because Textile link `"foo":http://www.example.com/` does not work without surrounding spaces. However, the text "bar" you will

get by converting from `<a name="Header-one">bar</a>` does not have any markup and will be always rendered properly. So, I think the surrounding

spaces are unnecessary.

#7 - 2019-11-06 22:38 - Marius BĂLTEANU

Go MAEDA wrote:

Marius BALTEANU wrote:

The current implementation fails with the following error if the link doesn't contain the href attribute.

 Thank you for catching and fixing the error.

2. A proposed fix, but I'm not sure if foo<a name="Header-one">bar</a>baz should be converted to foo bar baz or to foobarbaz.

 I think we can omit the surrounding spaces for that case. Text generated from `<a href="http://www.example.com/">foo</a>` style HTML should

have surrounding spaces because Textile link `"foo":http://www.example.com/` does not work without surrounding spaces. However, the text

"bar" you will get by converting from `<a name="Header-one">bar</a>` does not have any markup and will be always rendered properly. So, I

think the surrounding spaces are unnecessary.

 Great! Please feel free to update the patches.

#8 - 2019-11-09 07:06 - Go MAEDA

- Status changed from Reopened to Closed

Marius BALTEANU wrote:

The current implementation fails with the following error if the link doesn't contain the href attribute.
 Committed the patches. Thank you.

Files

fixed-31695.patch 4.05 KB 2019-07-08 Yuichi HARADA

tests_for_a_elements_without_href.patch 1.75 KB 2019-11-04 Marius BĂLTEANU

fix_for_links_without_href.patch 1.97 KB 2019-11-04 Marius BĂLTEANU

Powered by TCPDF (www.tcpdf.org)

2025-05-02 3/3

http://www.tcpdf.org

